# -*- coding: utf-8 -*-
#
# This file is part of the PythonThreading project
#
#
#
# Distributed under the terms of the GPL license.
# See LICENSE.txt for more info.

""" PythonThreading

"""

# PyTango imports
import PyTango
from PyTango import DebugIt
from PyTango.server import run
from PyTango.server import Device, DeviceMeta
from PyTango.server import attribute, command
from PyTango import AttrQuality, DispLevel, DevState
from PyTango import AttrWriteType, PipeWriteType
# Additional import
# PROTECTED REGION ID(PythonThreading.additionnal_import) ENABLED START #
import time
import threading
# PROTECTED REGION END #    //  PythonThreading.additionnal_import

__all__ = ["PythonThreading", "main"]


class PythonThreading(Device):
    """
    """
    __metaclass__ = DeviceMeta
    # PROTECTED REGION ID(PythonThreading.class_variable) ENABLED START #
    def element1_fun(self):
        print "In thread 1"
        self._element1_difference = self._source_attr[0] - self._target_attr[0]
        if self._element1_difference > 0.0:
            self.increment([0,self._element1_difference])
        elif self._element1_difference < 0.0:
            self.decrement([0,abs(self._element1_difference)])
        else:
            pass

    def element2_fun(self):
        print "In thread 2"
        self._element2_difference = self._source_attr[1] - self._target_attr[1]
        if self._element2_difference > 0.0:
            self.increment([1,self._element2_difference])
        elif self._element2_difference < 0.0:
            self.decrement([1,abs(self._element1_difference)])
        else:
            pass

    def increment(self,argin):
        for i in range(0,int(argin[1])):
            time.sleep(2)
            print ("Target is: %d %d" %(argin[0], self._target_attr[argin[0]]))
            self._target_attr[argin[0]] = self._target_attr[argin[0]] + 1

    def decrement(self,argin):
        for i in range(0,int(argin[1])):
            time.sleep(2)
            print ("Target is: %d %d" %(argin[0], self._target_attr[argin[0]]))
            self._target_attr[argin[0]] = self._target_attr[argin[0]] - 1


    # PROTECTED REGION END #    //  PythonThreading.class_variable

    # ----------
    # Attributes
    # ----------

    SourceAttr = attribute(
        dtype=('double',),
        access=AttrWriteType.WRITE,
        max_dim_x=2,
    )

    TargetAttr = attribute(
        dtype=('double',),
        max_dim_x=2,
    )

    # ---------------
    # General methods
    # ---------------

    def init_device(self):
        Device.init_device(self)
        # PROTECTED REGION ID(PythonThreading.init_device) ENABLED START #
        self._source_attr = [0.0, 0.0]
        self._target_attr = [0.0, 0.0]
        self._element1_difference = 0
        self._element2_difference = 0
        self.set_state(PyTango.DevState.ON)
        # PROTECTED REGION END #    //  PythonThreading.init_device

    def always_executed_hook(self):
        # PROTECTED REGION ID(PythonThreading.always_executed_hook) ENABLED START #
        pass
        # PROTECTED REGION END #    //  PythonThreading.always_executed_hook

    def delete_device(self):
        # PROTECTED REGION ID(PythonThreading.delete_device) ENABLED START #
        pass
        # PROTECTED REGION END #    //  PythonThreading.delete_device

    # ------------------
    # Attributes methods
    # ------------------

    def write_SourceAttr(self, value):
        # PROTECTED REGION ID(PythonThreading.SourceAttr_write) ENABLED START #
        self._source_attr = value
        pass
        # PROTECTED REGION END #    //  PythonThreading.SourceAttr_write

    def read_TargetAttr(self):
        # PROTECTED REGION ID(PythonThreading.TargetAttr_read) ENABLED START #
        return self._target_attr
        # PROTECTED REGION END #    //  PythonThreading.TargetAttr_read


    # --------
    # Commands
    # --------

    @command(
    )
    @DebugIt()
    def DuplicateSource(self):
        # PROTECTED REGION ID(PythonThreading.DuplicateSource) ENABLED START #
        if ((self._source_attr[0] != self._target_attr[0]) & (self._source_attr[1] != self._target_attr[1])):
            self.Thread1 = threading.Thread(None, self.element1_fun(), 'PythonThreading')
            self.Thread2 = threading.Thread(None, self.element2_fun(), 'PythonThreading')
        print "Source attribute is copied to Target attribute."
        pass
        # PROTECTED REGION END #    //  PythonThreading.DuplicateSource

# ----------
# Run server
# ----------


def main(args=None, **kwargs):
    # PROTECTED REGION ID(PythonThreading.main) ENABLED START #
    return run((PythonThreading,), args=args, **kwargs)
    # PROTECTED REGION END #    //  PythonThreading.main

if __name__ == '__main__':
    main()
